# MNIST inference example Using IBM Distributed Deep Learning

## About
The objective of these example scripts is to showcase training and inferencing separately on MNIST dataset. The `mnist_custom_model.py` script defines a custom model for MNIST dataset. This file is shared between the `mnist-custom-training.py`and `mnist-custom-inference.py`. The `mnist-custom-training.py` script demonstrates how to create a custom keras model and use IBM Distributed Deep Learning (DDL) for training. Then, `mnist-custom-inference.py`scipt along with the trained model can be ran on a separate machine for inferencing. Similarly, `mnist-seq-training.py` and `mnist-seq-inference.py` scripts shows training and inferencing using pre-defined layers in keras along with IBM Distributed Deep Learning (DDL).

## Running MNIST-keras

Before running either of the scripts, make sure there is a conda environment activated with the `ddl-tensorflow` package installed.

The examples should also be copied into a user directory by running the following command:

```bash
$ ddl-tensorflow-install-samples <somedir>
```

To run training scripts `mnist-custom-training.py` or `mnist-seq-training.py` on two machines named host1 and host2 that each have 4 GPUS, run one of the following:

```bash
$ ddlrun -H host1,host2 python mnist-custom-training.py
```

OR

```bash
$ ddlrun -H host1,host2 python mnist-seq-training.py
```

For inferencing run one of the following command depending on the training script ran above:

```bash
$ python mnist-custom-inference.py --saved_model_path <path to the trained model displayed by the training script>
```

OR

```bash
$ python mnist-seq-inference.py --saved_model_path <path to the trained model displayed by the training script>
```

&copy; Copyright IBM Corporation 2020
